using System;
using System.Text;
using Ceix30ClassLib;
using Ceix30ClassLib.api;
namespace Arinc429Example
{
	public class ceix30_example
	{
		static void Main(string[] args)
		{
			short board = 0;
			short channel = 0;
			int messageIndex = 0;
			int receivedMessage = 0;
         int status2;
         Int64 timeStamp = 0;

			api.AR_TIMETAG_TYPE timeTagStruct = new api.AR_TIMETAG_TYPE();
            api.AR_SCHEDULED_MSG_ENTRY_TYPE[] scheduledMessageSet = new api.AR_SCHEDULED_MSG_ENTRY_TYPE[] {
            new api.AR_SCHEDULED_MSG_ENTRY_TYPE(),
            new api.AR_SCHEDULED_MSG_ENTRY_TYPE()
         };

			// open a session with the CEI-x30 board
			short status = api.ar_loadslv (board, 0, 0, 0);
			if (status == api.ARS_NORMAL) 
			{
				Console.WriteLine("CEI-x30 Board " + board.ToString() + " initialization was successful." );

				// create some periodic messages at a 20Hz repeat rate, one on each for the first thwo channels
				short msgAssignment = api.ar_define_msg (board, 0, 50, 0, 0x01110101);
                msgAssignment = api.ar_define_msg (board, 1, 50, 0, 0x02220202);
   
				// enable reception with internal wrap
				status = api.ar_set_device_config ( board, 0, api.ARU_RECV_MODE, api.AR_WRAP_ON ); 
                status = api.ar_set_device_config ( board, 1, api.ARU_RECV_MODE, api.AR_WRAP_ON ); 
   
				// enable all board processing 
				status = api.ar_go (board);

				// insert a one-shot transmit message on the first channel
				msgAssignment = api.ar_putword (board, 0, 0x09990905);

				// attempt to receive up to 10 messages on 'channel', then terminate.
				for (messageIndex = 0; messageIndex < 10; messageIndex++) 
				{
					// invoke ar_getnext_xt to delay up to 1/2 second for the next message, using 64-bit time-tag structure for time-stamp
                    status = api.ar_getnext_xt(board, channel, ref receivedMessage, ref timeTagStruct);
					
					// if a message was received, display the message and time-stamp
					if (status == api.ARS_GOTDATA) 
					{
						Console.WriteLine("Channel " + channel.ToString() + " received message: $" + receivedMessage.ToString("X8") + " time-stamp: " + timeTagStruct.timeTag.ToString() );
					}
               status2 = api.ar_get_latest_t(board, channel, 5, ref receivedMessage, ref timeStamp);
            }
   
				// disable all board processing 
				status = api.ar_stop (board);
			}
			else
			{
				Console.WriteLine("CEI-x30 Board " + board.ToString() + " initialization failed with status code: " + status.ToString());
			}

			// terminate the session with the CEI-x30 board
			status = api.ar_close (board);
		}
	}
}
